﻿Imports System.Net
Imports System.Net.Mail
Imports System.Data
Imports System.Threading.Tasks
Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Dim dt As New DataTable()
            dt.Columns.AddRange(New DataColumn(2) {New DataColumn("Id", GetType(Integer)), _
                                                   New DataColumn("Name", GetType(String)), _
                                                   New DataColumn("Email", GetType(String))})
            dt.Rows.Add(1, "John Hammond", "john.hammond@test.com")
            dt.Rows.Add(2, "Mudassar Khan", "mudassar.khan@test.com")
            dt.Rows.Add(3, "Suzanne Mathews", "suzzane.mathews@test.com")
            dt.Rows.Add(4, "Robert Schidner", "robert.schidner@test.com")
            GridView1.DataSource = dt
            GridView1.DataBind()
        End If
    End Sub

    Protected Sub SendBulkEmail(sender As Object, e As EventArgs)
        'Create a temporary DataTable
        Dim dtCustomers As New DataTable()
        dtCustomers.Columns.AddRange(New DataColumn(1) {New DataColumn("Name", GetType(String)), New DataColumn("Email", GetType(String))})

        'Copy the Checked Rows to DataTable
        For Each row As GridViewRow In GridView1.Rows
            If TryCast(row.FindControl("chkSelect"), CheckBox).Checked Then
                dtCustomers.Rows.Add(row.Cells(2).Text, TryCast(row.FindControl("lnkEmail"), HyperLink).Text)
            End If
        Next

        Dim subject As String = "Welcome Email"
        Dim body As String = "Hello {0},<br /><br />Welcome to ASPSnippets<br /><br />Thanks."

        'Using Parallel Multi-Threading send multiple bulk email.
        Parallel.ForEach(dtCustomers.AsEnumerable(), _
                         Function(row)
                             Return SendEmail(row("Email").ToString(), subject, String.Format(body, row("Name")))
                         End Function)
    End Sub

    Private Function SendEmail(recipient As String, subject As String, body As String) As Boolean
        Dim mm As New MailMessage("sender@gmail.com", recipient)
        mm.Subject = subject
        mm.Body = body
        mm.IsBodyHtml = True
        Dim smtp As New SmtpClient()
        smtp.Host = "smtp.gmail.com"
        smtp.EnableSsl = True
        Dim NetworkCred As New NetworkCredential()
        NetworkCred.UserName = "sender@gmail.com"
        NetworkCred.Password = "<password>"
        smtp.UseDefaultCredentials = True
        smtp.Credentials = NetworkCred
        smtp.Port = 587
        smtp.Send(mm)
        Return True
    End Function
End Class
